import 'dart:async';

import 'package:flutter/services.dart';
import 'package:flutter_bk_ua/UAModel.dart';

const MethodChannel _channel = const MethodChannel('flutter_bk_ua');

FutureOr<UAModel> getUserAgent() async {
  final ua = await _channel.invokeMethod('getUserAgent');

  return UAModel(
    platform: ua['platform'],
    platformVersion: ua['platformVersion'],
    architecture: ua['architecture'],
    model: ua['model'],
    mobile: ua['mobile'],
    device: ua['device'],
    appName: ua['appName'],
    packageName: ua['packageName'],
    appVersion: ua['appVersion'],
  );
}

FutureOr<String> getUAHeader({String delimiter = ';'}) async {
  final ua = await _channel.invokeMethod('getUserAgent');

  final uaModel = UAModel(
    platform: ua['platform'],
    platformVersion: ua['platformVersion'],
    architecture: ua['architecture'],
    model: ua['model'],
    mobile: ua['mobile'],
    device: ua['device'],
    appName: ua['appName'],
    packageName: ua['packageName'],
    appVersion: ua['appVersion'],
  );

  return [
    uaModel.appName,
    uaModel.packageName,
    uaModel.appVersion,
    uaModel.device,
    '${uaModel.platform} ${uaModel.platformVersion}',
  ].join(delimiter);
}
